=== changelog ===
earthworm (7.10-1ubuntu1) UNRELEASED; urgency=medium

  * Initial release. 
  * Adding in new version of Swarm (2.8.7)

 -- Alexander Schnackenberg <a.schnackenberg@isti.com>  Tue, 05 Feb 2019 13:57:06 -0500
