=== control ===
Source: earthworm
Section: science
Priority: optional
Maintainer: Alexander Schnackenberg <a.schnackenberg@isti.com>
Build-Depends: debhelper (>= 10)
Standards-Version: 4.3.0.1
Homepage: www.earthwormcentral.org

Package: earthworm
Architecture: any
Depends: libgfortran4
Description: Earthworm provides users with an advanced open source seismic data acquisition and processing
 capable of calculating earthquake locations and magnitudes.
 . 
 The Earthworm system is a robust and mature software tool, incorporating over 25 years of design and
 development.
